use 5.006;
use strict;
use warnings;

# this test was generated with Dist::Zilla::Plugin::Test::Compile 2.043

use Test::More  tests => 19 + ($ENV{AUTHOR_TESTING} ? 1 : 0);



my @module_files = (
    'ETL/Yertl.pm',
    'ETL/Yertl/Command/yfrom.pm',
    'ETL/Yertl/Command/ygrok.pm',
    'ETL/Yertl/Command/ymask.pm',
    'ETL/Yertl/Command/yq.pm',
    'ETL/Yertl/Command/yq/RecDescent.pm',
    'ETL/Yertl/Command/yq/RecDescentTree.pm',
    'ETL/Yertl/Command/yq/Regex.pm',
    'ETL/Yertl/Command/ysql.pm',
    'ETL/Yertl/Command/yto.pm',
    'ETL/Yertl/Format/csv.pm',
    'ETL/Yertl/Format/json.pm',
    'ETL/Yertl/Format/yaml.pm'
);

my @scripts = (
    'bin/yfrom',
    'bin/ygrok',
    'bin/ymask',
    'bin/yq',
    'bin/ysql',
    'bin/yto'
);

# no fake home requested

my $inc_switch = -d 'blib' ? '-Mblib' : '-Ilib';

use File::Spec;
use IPC::Open3;
use IO::Handle;

open my $stdin, '<', File::Spec->devnull or die "can't open devnull: $!";

my @warnings;
for my $lib (@module_files)
{
    # see L<perlfaq8/How can I capture STDERR from an external command?>
    my $stderr = IO::Handle->new;

    my $pid = open3($stdin, '>&STDERR', $stderr, $^X, $inc_switch, '-e', "require q[$lib]");
    binmode $stderr, ':crlf' if $^O eq 'MSWin32';
    my @_warnings = <$stderr>;
    waitpid($pid, 0);
    is($?, 0, "$lib loaded ok");

    if (@_warnings)
    {
        warn @_warnings;
        push @warnings, @_warnings;
    }
}

foreach my $file (@scripts)
{ SKIP: {
    open my $fh, '<', $file or warn("Unable to open $file: $!"), next;
    my $line = <$fh>;

    close $fh and skip("$file isn't perl", 1) unless $line =~ /^#!\s*(?:\S*perl\S*)((?:\s+-\w*)*)(?:\s*#.*)?$/;
    my @flags = $1 ? split(' ', $1) : ();

    my $stderr = IO::Handle->new;

    my $pid = open3($stdin, '>&STDERR', $stderr, $^X, $inc_switch, @flags, '-c', $file);
    binmode $stderr, ':crlf' if $^O eq 'MSWin32';
    my @_warnings = <$stderr>;
    waitpid($pid, 0);
    is($?, 0, "$file compiled ok");

   # in older perls, -c output is simply the file portion of the path being tested
    if (@_warnings = grep { !/\bsyntax OK$/ }
        grep { chomp; $_ ne (File::Spec->splitpath($file))[2] } @_warnings)
    {
        warn @_warnings;
        push @warnings, @_warnings;
    }
} }



is(scalar(@warnings), 0, 'no warnings found') if $ENV{AUTHOR_TESTING};


